<?php

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
namespace SistemaQualidade\Logic\Acao;
/**
 * Description of Aczao
 *
 * @author gabrielcapanema
 */
class Acao {

    public static function insereSituacaoDaAcao($arraySituacao){
        $db = \Setforms2\Runtime\Connection::getInstance();
        $db->getConn()->beginTransaction();
        $connection = \Setforms2\Shared\Registry::getEntityManager();
        $situacao = \SistemaQualidade\Entities\Acao::findOneByNrorgAndNracao($arraySituacao['NRORG'], $arraySituacao['NRACAO']);
        
        if ($arraySituacao['DTENCEACAO']) {
            $dtenceacao = \Geral\Util\DateUtil::getDataDeString($arraySituacao['DTENCEACAO'], "d/m/Y H:i:s");
        }

        if ($arraySituacao['DTPREVENCEAC']) {
            $dtprevenceac = \Geral\Util\DateUtil::getDataDeString($arraySituacao['DTPREVENCEAC']);
        }

        try{ 
            $situacao->setCdfilial($arraySituacao['CDFILIAL']);           
            $situacao->setIdacaoence($arraySituacao['IDACAOENCE']);
            $situacao->setDtenceacao($dtenceacao);
            $situacao->setDtprevenceac($dtprevenceac);
            $situacao->setCdoperaval($arraySituacao['CDOPERAVAL']);
            
            $situacao->persist();
            
            $connection->flush();
            $db->getConn()->commit();                
        }catch(\Exception $e){
            $db->getConn()->rollback();
            throw $e;
        }

    }

    public static function insereAcompanhamentoDaAcao($arrayAcompanhamento){
        $db = \Setforms2\Runtime\Connection::getInstance();
        $db->getConn()->beginTransaction();
        $connection = \Setforms2\Shared\Registry::getEntityManager();
        $acompanhamento = \SistemaQualidade\Entities\Acao::findOneByNrorgAndNracao($arrayAcompanhamento['NRORG'], $arrayAcompanhamento['NRACAO']);
        
        if ($arrayAcompanhamento['DTPREVINICAC']) {
            $dtprevinicac = \Geral\Util\DateUtil::getDataDeString($arrayAcompanhamento['DTPREVINICAC']);
        }

        if ($arrayAcompanhamento['DTPREVENCEAC']) {
            $dtprevenceac = \Geral\Util\DateUtil::getDataDeString($arrayAcompanhamento['DTPREVENCEAC']);
        }


        try{ 
            $acompanhamento->setDtprevinicac($dtprevinicac);           
            $acompanhamento->setDtprevenceac($dtprevenceac);
            
            $acompanhamento->persist();
            
            $connection->flush();
            $db->getConn()->commit();                
        }catch(\Exception $e){
            $db->getConn()->rollback();
            throw $e;
        }
    }

    public static function insereAlteracaoPrevisaoDaAcao($arrayAlteracao){
        $db = \Setforms2\Runtime\Connection::getInstance();
        $db->getConn()->beginTransaction();
        $connection = \Setforms2\Shared\Registry::getEntityManager();
        
        if ($arrayAlteracao['DTNOVAPREVAC']) {
            $dtnovaprevac = \Geral\Util\DateUtil::getDataDeString($arrayAlteracao['DTNOVAPREVAC'], "d/m/Y");
        }

        if ($arrayAlteracao['DTALPREVACAO']) {
            $dtalprevacao = \Geral\Util\DateUtil::getDataDeString($arrayAlteracao['DTALPREVACAO'], "d/m/Y H:i:s");
        }
        try{
            $alteracao = new \SistemaQualidade\Entities\Logprevacao(); 
            $alteracao->setDtnovaprevac($dtnovaprevac);           
            $alteracao->setDtalprevacao($dtalprevacao);
            $alteracao->setNracao($arrayAlteracao['NRACAO']);
            $alteracao->setNrorg($arrayAlteracao['NRORG']);
            $alteracao->setCdoperador($arrayAlteracao['CDOPERADOR']);
            $alteracao->setIdativo('S');
            
            $alteracao->persist();
            
            $connection->flush();
            $db->getConn()->commit();                
        }catch(\Exception $e){
            $db->getConn()->rollback();
            throw $e;
        }
    }

    public static function retornaNomeOperador($operadorVisto, $nrorgoper){
        $operador = \Geral\Entities\Operador::findOneByCdoperadorAndNrorg($operadorVisto, $nrorgoper);
        return $operador->getNmoperador();
    }   

    public static function retornaNmsetor($cdsetor, $nrorg){
        $setor = \Geral\Entities\Setor::findOneByCdsetorAndNrorg($cdsetor, $nrorg);
        return $setor->getNmsetor();
    }

    public static function deletaChildsAcao($nracao, $nrorg){
        $logtramacao = \SistemaQualidade\Entities\Logtramacao::findByNracaoAndNrorg($nracao, $nrorg);
        $logprevacao = \SistemaQualidade\Entities\Logprevacao::findByNracaoAndNrorg($nracao, $nrorg);
        $etapacao    = \SistemaQualidade\Entities\Etapacao::findByNracaoAndNrorg($nracao, $nrorg);
        $obsacao     = \SistemaQualidade\Entities\Obsacao::findByNracaoAndNrorg($nracao, $nrorg);

        $db = \Setforms2\Runtime\Connection::getInstance();        
        $db->getConn()->beginTransaction();
        $connection = \Setforms2\Shared\Registry::getEntityManager();
                
        try{
            foreach($logtramacao as $obj){
                $obj->delete();
            }   
            foreach($logprevacao as $obj){
                $obj->delete();
            }
            foreach($etapacao as $obj){
                $obj->delete();
            }
            foreach($obsacao as $obj){
            $obj->delete();
            }
            $connection->flush();
            $db->getConn()->commit();

        }

        catch(\Exception $e){
            $db->getConn()->rollback();
            throw $e;
        }

    }

    public static function insereFaseDaAcao($arrayFase){
        $db = \Setforms2\Runtime\Connection::getInstance();
        $db->getConn()->beginTransaction();
        $connection = \Setforms2\Shared\Registry::getEntityManager();
        $fase = \SistemaQualidade\Entities\Acao::findOneByNrorgAndNracao($arrayFase['NRORG'], $arrayFase['NRACAO']);

        if ($arrayFase['DTULTATUACAO']) {
            $dtultatuacao = \Geral\Util\DateUtil::getDataDeString($arrayFase['DTULTATUACAO'], "d/m/Y H:i:s");
        }


        try{ 
            $fase->setDtultatuacao($dtultatuacao);           
            $fase->setCdfatramacao($arrayFase['CDFATRAMACAO']);
            
            $fase->persist();
            
            $connection->flush();
            $db->getConn()->commit();              
        }
        catch(\Exception $e){
            $db->getConn()->rollback();
            throw $e;
        }
    }

    public static function afterDeleteFase($arrayFase){
        $fase = \SistemaQualidade\Entities\Logtramacao::findByNrorgAndNracao($arrayFase['NRORG'], $arrayFase['NRACAO']);
        
        $maiordata = \Geral\Util\DateUtil::getDataDeString('01/01/1900', "d/m/Y");

        foreach($fase as $obj){
            $data = $obj->getDtaltramacao();

            if(\Geral\Util\DateUtil::comparaDatas($maiordata, $data)){
                $maiordata = $data;
                $faseAtual = $obj->getCdfatramacao();
            }
        }

        $db = \Setforms2\Runtime\Connection::getInstance();
        $db->getConn()->beginTransaction();
        $connection = \Setforms2\Shared\Registry::getEntityManager();
        $fase = \SistemaQualidade\Entities\Acao::findOneByNrorgAndNracao($arrayFase['NRORG'], $arrayFase['NRACAO']);
        
        if ($arrayFase['DTULTATUACAO']) {
            $dtultatuacao = \Geral\Util\DateUtil::getDataDeString($arrayFase['DTULTATUACAO'], "d/m/Y H:i:s");
        }


        try{ 
            $fase->setDtultatuacao($dtultatuacao);           
            $fase->setCdfatramacao($faseAtual);
            
            $fase->persist();
            
            $connection->flush();
            $db->getConn()->commit();                
        }catch(\Exception $e){
            $db->getConn()->rollback();
            throw $e;
        }
    }

    public static function getDataSituacao($nrorg, $nracao){
        $acao = \SistemaQualidade\Entities\Acao::findOneByNrorgAndNracao($nrorg, $nracao);
        

         $array = array (    
            'DTENCEACAO' => $acao->getDtenceacao(),
            'IDACAOENCE' => $acao->getIdacaoence()
        );

        return $array;

    }

        
}